package com.hzya.frame.plugin.masterData.org.plugin;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.sysnew.comparison.masterData.service.impl.MasterDataOrgsServiceImpl;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 组织档案(MdmOrg)表服务接口
 *
 * @author makejava
 * @since 2024-06-07 18:30:05
 */
public class MdmOrgPluginInitializer extends PluginBaseEntity{
    Logger logger = LoggerFactory.getLogger(MdmOrgPluginInitializer.class);
    @Autowired
    private MasterDataOrgsServiceImpl masterDataOrgsService;

      @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "MdmOrgPlugin";
    }

    @Override
    public String getPluginName() {
        return "MdmOrgPlugin插件";
    }

    @Override
    public String getPluginLabel() {
        return "MdmOrgPlugin";
    }

    @Override
    public String getPluginType() {
        return "1";
    }
    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {
          try {
              logger.info("======开始执行主数据档案组织档案同步========");
             return masterDataOrgsService.queryOrgsArchives(requestJson);
          }catch (Exception e){
              logger.info("======执行主数据档案组织档案同步失败:{}========",e.getMessage());
              e.printStackTrace();
          }
          return null;
    }
}
